牛客小白月赛 90 (全)

文章描述了几道编程竞赛题目,涉及贪心算法、数组操作、线段树、优先队列等技术,展示了在解决不同难度问题时所用的不同策略。

摘要生成于 C知道 ,由 DeepSeek-R1 满血版支持, 前往体验 >

评价:

好像比上次月赛简单100倍。

A题: 小A的文化节

签到题

#include <bits/stdc++.h>
using namespace std;
int main() {
    ios::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    int n, m; cin >> n >> m;
    vector<int> a(n + 1);
    for (int i = 1; i <= n; i ++ ) cin >> a[i];
    int ans = 0;
    while (m -- ) {
        int op; cin >> op;
        ans += a[op];
    }
    cout << ans << endl;
    return 0;
}

B题:  小A的游戏 

 记平局数量为c,小A赢了a局,小B赢了b局

 题目输入的是x和y

 那么 x = c + 3 * a , y = c + 3 * b

 暴力想法肯定是枚举a算出c带入y

 但是肯定会超时

 我们这样做的目的只是在探求a和b之间的关系而已

 所以不妨相减可得 y - x = 3 * (b - a)

 b和a都是整数,所以y - x是3的倍数即可。

#include <bits/stdc++.h>
using namespace std;
int main() {
    ios::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    int t; cin >> t;
    while (t -- ) {
        int x, y;
        cin >> x >> y;
        if (abs(x - y) % 3 == 0) cout << "Yes\n";
        else cout << "No\n";
    }
    return 0;
}

C题: 小A的数字 

贪心。

单拎出个位数的情况,根据题意,我们只要输出1即可。

否则判断是否出现过0

如果出现过0,那么之后的每一位上都要有数字。

可证为0时输出1,不为0时输出0时最小。

没有出现过0,那么只要输出个位数当作最小,判断最末尾的那一个数即可。

#include <bits/stdc++.h>
using namespace std;
int main() {
    ios::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    int t; cin >> t;
    while (t -- ) {
        string s; cin >> s;
        if (s.size() == 1) {
            cout << 1 << endl;
            continue;
        }
        bool ok = false;
        for (int i = 0; i < s.size(); i ++ ) {
            if (ok && s[i] != '0') cout << 0;
            if (s[i] == '0') {
                ok = true;
                cout << 1;
            }
        }
        if (!ok) {
            if (s[s.size() - 1] == '1') cout << 2;
            else cout << 1;
        }
        cout << endl;
    }
    return 0;
}

 D题: 小A的线段(easy version)

显然暴力dfs,可以加上差分优化

#include <bits/stdc++.h>
using namespace std;
using ll = long long;
const int N = 1e5 + 9;
const int mod = 998244353;
int l[11], r[11], d[N];
int n, m;
ll ans;
inline void dfs(int u) {
    if (u == m + 1) {
        int pre[N] = {};
        for (int i = 1; i <= n; i ++ ) {
            pre[i] = pre[i - 1] + d[i];
            if (pre[i] < 2) return;
        }
        ans = (ans + 1) % mod;
        return;
    }
    d[l[u]] ++, d[r[u] + 1] --;
    dfs(u + 1);
    d[l[u]] --, d[r[u] + 1] ++;
    dfs(u + 1);
}
int main() {
    ios::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    cin >> n >> m;
    for (int i = 1; i <= m; i ++ ) {
        cin >> l[i] >> r[i];
    }
    dfs(1);
    cout << ans << endl;
    return 0;
}

E题: 小A的任务 

贪心。如果我们完成了a个A任务(a >= k),那么我们需要的是a个B任务中耗时间最小的k个,这可以通过优先队列实现。每次往里面加入一个,然后弹出最大的那一个。

#include <bits/stdc++.h>
using namespace std;
using ll = long long;
int main() {
    ios::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    int n, q; cin >> n >> q;
    vector<ll> a(n + 1), b(n + 1);
    for (int i = 1; i <= n; i ++ ) {
        cin >> a[i];
        a[i] += a[i - 1];
    }
    for (int i = 1; i <= n; i ++ ) cin >> b[i];
    while (q -- ) {
        int k; cin >> k;
        priority_queue<int> heap;
        ll sum = 0, ans = 1e18;
        for (int i = 1; i <= n; i ++ ) {
            heap.push(b[i]);
            sum += b[i];
            if (heap.size() > k) sum -= heap.top(), heap.pop();
            if (heap.size() == k) ans = min(ans, sum + a[i]);
        }
        cout << ans << endl;
    }
    return 0;
}

F题: 小A的线段(hard version)

#include <bits/stdc++.h>
using namespace std;
typedef pair<int, int> PII;
const int mod = 998244353;
PII p[210];
int dp[210][410][410];
inline void add(int &t, int d) {
    t += d;
    if (t >= mod) t -= mod;
}
int main() {
    ios::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    int n, m;
    cin >> n >> m;
    vector<int> d;
    for (int i = 1; i <= m; i ++ ) {
        int l, r;
        cin >> l >> r;
        l --;
        p[i] = {l, r};
        d.push_back(l), d.push_back(r);
    }
    d.push_back(0), d.push_back(n);
    sort(d.begin(), d.end());
    d.erase(unique(d.begin(), d.end()), d.end());
    n = d.size();
    sort(p + 1, p + 1 + m);
    for (int i = 1; i <= m; i ++ ) {
        p[i].first = lower_bound(d.begin(), d.end(), p[i].first) - d.begin();
        p[i].second = lower_bound(d.begin(), d.end(), p[i].second) - d.begin();
    }
    dp[0][0][0] = 1;
    for (int k = 1; k <= m; k ++ ) {
        for (int i = 0; i < n; i ++ ) {
            for (int j = i; j < n; j ++ ) {
                if (dp[k - 1][i][j] == 0) continue;
                add(dp[k][i][j], dp[k - 1][i][j]);
                if (p[k].first <= i) {
                    add(dp[k][max(i, min(j, p[k].second))][max(j, p[k].second)], dp[k - 1][i][j]);
                }
            }
        }
    }
    cout << dp[m][n - 1][n - 1] << endl;
    return 0;
}

### 关于小白109的信息 目前并未找到关于小白109的具体比信息或题解内容[^5]。然而,可以推测该事可能属于网举办的系列算法之一,通常这类比会涉及数据结构动态规划、图论等经典算法问题。 如果要准备类似的事,可以通过分析其他场次的比题目来提升自己的能力。例如,在小白13中,有一道与二叉树相关的题目,其核心在于处理树的操作以及统计最终的结果[^3]。通过研究此类问题的解决方法,能够帮助理解如何高效地设计算法并优化时间复杂度。 以下是基于已有经验的一个通用解决方案框架用于应对类似场景下的批量更新操作: ```python class TreeNode: def __init__(self, id): self.id = id self.weight = 0 self.children = [] def build_tree(n): nodes = [TreeNode(i) for i in range(1, n + 1)] for node in nodes: if 2 * node.id <= n: node.children.append(nodes[2 * node.id - 1]) if 2 * node.id + 1 <= n: node.children.append(nodes[2 * node.id]) return nodes[0] def apply_operations(root, operations, m): from collections import defaultdict counts = defaultdict(int) def update_subtree(node, delta): stack = [node] while stack: current = stack.pop() current.weight += delta counts[current.weight] += 1 for child in current.children: stack.append(child) def exclude_subtree(node, total_nodes, delta): nonlocal root stack = [(root, False)] # (current_node, visited) subtree_size = set() while stack: current, visited = stack.pop() if not visited and current != node: stack.append((current, True)) for child in current.children: stack.append((child, False)) elif visited or current == node: if current != node: subtree_size.add(current.id) all_ids = {i for i in range(1, total_nodes + 1)} outside_ids = all_ids.difference(subtree_size.union({node.id})) for idx in outside_ids: nodes[idx].weight += delta counts[nodes[idx].weight] += 1 global nodes nodes = {} queue = [root] while queue: curr = queue.pop(0) nodes[curr.id] = curr for c in curr.children: queue.append(c) for operation in operations: op_type, x = operation.split(' ') x = int(x) target_node = nodes.get(x, None) if not target_node: continue if op_type == '1': update_subtree(target_node, 1) elif op_type == '2' and target_node is not None: exclude_subtree(target_node, n, 1) elif op_type == '3': path_to_root = [] temp = target_node while temp: path_to_root.append(temp) if temp.id % 2 == 0: parent_id = temp.id // 2 else: parent_id = (temp.id - 1) // 2 if parent_id >= 1: temp = nodes[parent_id] else: break for p in path_to_root: p.weight += 1 counts[p.weight] += 1 elif op_type == '4': pass # Implement similarly to other cases. result = [counts[i] for i in range(m + 1)] return result ``` 上述代码片段展示了针对特定类型的树形结构及其操作的一种实现方式。尽管它并非直接对应小白109中的具体题目,但它提供了一个可借鉴的设计思路。 ####
评论 1
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值